[![arduino-library-badge](https://www.ardu-badge.com/badge/GyverPortal.svg?)](https://www.ardu-badge.com/GyverPortal)
[![Foo](https://img.shields.io/badge/Website-AlexGyver.ru-blue.svg?style=flat-square)](https://alexgyver.ru/)
[![Foo](https://img.shields.io/badge/%E2%82%BD$%E2%82%AC%20%D0%9D%D0%B0%20%D0%BF%D0%B8%D0%B2%D0%BE-%D1%81%20%D1%80%D1%8B%D0%B1%D0%BA%D0%BE%D0%B9-orange.svg?style=flat-square)](https://alexgyver.ru/support_alex/)
[![Foo](https://img.shields.io/badge/README-ENGLISH-blueviolet.svg?style=flat-square)](/README_EN.md)

[![Foo](https://img.shields.io/badge/ПОДПИСАТЬСЯ-НА%20ОБНОВЛЕНИЯ-brightgreen.svg?style=social&logo=telegram&color=blue)](https://t.me/GyverLibs)

# GyverPortal
> **Библиотека обновлена до версии 2.0: оптимизация и полная поддержка ESP32!** 
Есть изменения в логике работы и частичная несовместимость, читай доку прежде чем обновиться.

Простой конструктор веб интерфейса для esp8266 и ESP32
- Простой конструктор - делаем страницы без знаний HTML и CSS
- Библиотека является обёрткой для стандартной ESP8266WebServer
- Позволяет быстро создать вебморду для управления и настройки своего девайса
- Компактный читаемый код в "скетче", никаких внешних обработчиков и лямбда-функций
- Конструктор использует стандартные HTML формы, CSS и javascript
- Элементы конструктора хранятся во Flash памяти
- Никаких глобальных буферов, всё генерируется на лету
- Приятный дизайн из коробки + тёмная тема
- Адаптировано под мобильные устройства и ПК
- Встроенные инструменты для удобного парсинга значений с формы
- Возможность настроить автоматическое обновление значений переменных по действию со страницы
- Встроенные жабаскрипты для AJAX, работа без обновления всей страницы:
  - Клики по компонентам, изменение их значений
  - Обновление компонентов по таймеру
  - График в реальном времени
  - Текстовое окно отладки (отправляем из программы)
- Компоненты конструктора:
  - Заголовок
  - Подпись
  - Разделитель
  - Перенос строки
  - Блок для объединения компонентов
  - Веб-форма (блок)
  - Кнопка submit (для форм)
  - Поле ввода текста
  - Многострочное поле ввода текста
  - Поле ввода пароля
  - Галочка (чекбокс)
  - Выключатель
  - Слайдер
  - Слайдер с подписью
  - Выбор времени
  - Выбор даты
  - Селектор (дропбокс)
  - Кнопка
  - Мини кнопка
  - "Светодиод" индикатор
  - Окно лога для отладки (веб Serial порт)
  - Несколько типов графиков (требуется интернет)

![demo](/docs/demoBig.png)  

### Возможности
Библиотека позволяет генерировать динамический веб интерфейс для управления своим электронным устройством из браузера (нужно зайти на IP адрес платы в строке адреса). Три основных способа взаимодействия с интерфейсом и сценарии использования:
- **Форма и кнопка отправить**: при нажатии на кнопку submit страница перезагружается, а в программу приходят данные со всех компонентов, входящих в форму (текст в поле ввода, положения слайдеров и чекбоксов, и так далее). Удобно для однократного ввода данных (настройки подключения и тому подобное).
- **Клик по компоненту**: при клике на почти любой компонент интерфейса (при изменении его состояния или значения) можно получить его актуальное значение без перезагрузки страницы. Удобно для управления и настройки (галочки, кнопки, слайдеры).
- **Обновление** значений и состояний компонентов в реальном времени без перезагрузки страницы. Удобно для индикации работы и получения текущих численных и текстовых значений из программы, вывод графиков в реальном времени.

### Совместимость
esp8266, esp32

## Содержание
- [Установка](#install)
- [Инициализация](#init)
- [Документация](#docs)
- [Использование](#usage)
  - [Начало работы](#setup)
  - [Конструктор](#build)
  - [Режим форм](#form)
  - [Режим кликов](#click)
  - [Режим обновлений](#update)
  - [Автообновление переменных](#auto)
  - [Графики](#plots)
  - [Лог](#log)
  - [Свои компоненты, API](#api)
- [Примеры](#example)
- [Версии](#versions)
- [Баги и обратная связь](#feedback)

<a id="install"></a>
## Установка
- Библиотеку можно найти по названию **GyverPortal** и установить через менеджер библиотек в:
    - Arduino IDE
    - Arduino IDE v2
    - PlatformIO
- [Скачать библиотеку](https://github.com/GyverLibs/GyverPortal/archive/refs/heads/main.zip) .zip архивом для ручной установки:
    - Распаковать и положить в *C:\Program Files (x86)\Arduino\libraries* (Windows x64)
    - Распаковать и положить в *C:\Program Files\Arduino\libraries* (Windows x32)
    - Распаковать и положить в *Документы/Arduino/libraries/*
    - (Arduino IDE) автоматическая установка из .zip: *Скетч/Подключить библиотеку/Добавить .ZIP библиотеку…* и указать скачанный архив
- Читай более подробную инструкцию по установке библиотек [здесь](https://alexgyver.ru/arduino-first/#%D0%A3%D1%81%D1%82%D0%B0%D0%BD%D0%BE%D0%B2%D0%BA%D0%B0_%D0%B1%D0%B8%D0%B1%D0%BB%D0%B8%D0%BE%D1%82%D0%B5%D0%BA)
### Обновление
- Рекомендую всегда обновлять библиотеку: в новых версиях исправляются ошибки и баги, а также проводится оптимизация и добавляются новые фичи
- Через менеджер библиотек IDE: найти библиотеку как при установке и нажать "Обновить"
- Вручную: **удалить папку со старой версией**, а затем положить на её место новую. "Замену" делать нельзя: иногда в новых версиях удаляются файлы, которые останутся при замене и могут привести к ошибкам!


<a id="init"></a>
## Инициализация
`GyverPortal portal;`

<a id="docs"></a>
## Документация
<details>
<summary>Функции конструктора</summary>

```cpp
// создание страницы
BUILD_BEGIN();                      // начать построение. Добавляет начальный HTML код
BUILD_END();                        // завершить построение. Добавляет завершающий HTML код

// темы
GP.THEME(тема);                    // установить тему
GP_LIGHT    - светлая тема
GP_DARK     - тёмная тема

// создание формы
GP.FORM_BEGIN(имя);                // начать форму с именем (имя)
GP.FORM_END();                     // завершить форму

// пустая форма с одной кнопкой
GP.FORM_SUBMIT(имя, текст);        // форма с именем (имя) кнопкой (текст)

// компоненты формы
GP.BUTTON(имя, текст);             // кнопка
GP.BUTTON(имя, текст, id);         // кнопка (id компонента, данные с которого кнопка отправит данные по click)
GP.BUTTON_MINI(имя, текст);        // мини кнопка
GP.BUTTON_MINI(имя, текст, id);    // мини кнопка (id компонента, данные с которого кнопка отправит данные по click)

GP.NUMBER(имя, подсказка, число);  // поле ввода текста, число
GP.TEXT(имя, подсказка, текст);    // поле ввода текста
GP.PASS(имя, подсказка, текст);    // поле ввода пароля
GP.CHECK(имя);                     // чекбокс, умолч. выключен
GP.CHECK(имя, состояние);          // чекбокс
GP.SWITCH(имя);                    // выключатель, умолч. выключен
GP.SWITCH(имя, состояние);         // выключатель
GP.DATE(имя);                      // ввод даты, умолч. пустой
GP.DATE(имя, GPdate);              // ввод даты
GP.TIME(имя);                      // ввод времени, умолч. пустой
GP.TIME(имя, GPtime);              // ввод времени
GP.SELECT(имя, список);            // селектор (дропбокс), элементы списка разделены запятой. Список может быть PSTR
GP.SELECT(имя, список, активный);  // + текущий активный пункт
GP.SLIDER(имя, число, мин, макс);                // слайдер
GP.SLIDER(имя, число, мин, макс, шаг);           // слайдер
GP.SLIDER(имя, подпись, число, мин, макс);       // слайдер с подписью
GP.SLIDER(имя, подпись, число, мин, макс, шаг);  // слайдер с подписью
GP.COLOR(имя);                     // выбор цвета, умолч. чёрный
GP.COLOR(имя, число);              // выбор цвета
GP.SUBMIT(текст);                  // кнопка отправки формы
GP.LED_RED(имя);                   // красный светодиод-индикатор
GP.LED_GREEN(имя);                 // зелёный светодиод-индикатор

// прочее для оформления
GP.TITLE(текст);                   // заголовок
GP.TITLE(текст, имя);              // + имя компонента (для update())
GP.LABEL(текст);                   // подпись (для кнопок, полей, чекбоксов итд)
GP.LABEL(текст, имя);              // + имя компонента (для update())
GP.LABEL(число);                   // подпись, число
GP.LABEL(число, имя);              // + имя компонента (для update())
GP.AREA(имя, к-во строк, текст);   // большое поле ввода текста
GP.AREA(имя, к-во строк);          // большое поле ввода текста
GP.BREAK();                        // перенести строку
GP.HR();                           // горизонтальный разделитель
GP.BLOCK_BEGIN();                  // начать отрисовку блока
GP.BLOCK_END();                    // завершить отрисовку блока

// прочее
GP.AJAX_UPDATE(список, период);    // передать список обновления компонентов
// для списка можно использовать макрос PSTR

// большое поле для ввода текста
GP.AREA(имя, к-во строк, текст);
GP.AREA(имя, к-во строк);
GP.AREA(имя);

// графики
// лёгкий статичный график без масштаба
GP.PLOT<к-во осей, к-во данных>(имя, подписи, данные int16_t, int dec = 0)
GP.PLOT_DARK<к-во осей, к-во данных>(имя, подписи, данные int16_t, int dec = 0)

// статический график с масштабом и привязкой ко времени
GP.PLOT_STOCK<к-во осей, к-во данных>(имя, подписи, массив времён, массив данных, int dec = 0)
GP.PLOT_STOCK_DARK<к-во осей, к-во данных>(имя, подписи, массив времён, массив данных, int dec = 0)

// динамический график, вызывает update
GP.AJAX_PLOT(имя, к-во осей, к-во точек по Х, период update);
GP.AJAX_PLOT_DARK(имя, к-во осей, к-во точек по Х, период update);

// создание кастомной страницы
GP_BUILD(строка);                   // запустить конструктор (можно вызывать где угодно)
GP_SHOW();                          // отобразить страницу (вызывать только внутри функции конструктора!)
GP.PAGE_BEGIN();                   // начальный HTML код
GP.PAGE_BLOCK_BEGIN()              // центральный div блок
GP.PAGE_BLOCK_END()                // центральный div блок
GP.PAGE_END();                     // завершающий HTML код
GP.AJAX_CLICK();                   // обработчик кликов
```
</details>

<details>
<summary>Методы класса</summary>

```cpp
// система
void start();                       // запустить портал
void start("host");                 // запуск с поддержкой mDNS, указать адрес (см. доку).
void start("host", port);           // запуск с поддержкой mDNS и указанием порта. Если mDNS не нужен - передай ""
void stop();                        // остановить портал// показать свою страницу

// подключение
void attachBuild(func);             // подключить функцию-билдер страницы
void attach(func);                  // подключить функцию-обработчик действия
void attach(func(GyverPortal&));    // подключить функцию-обработчик действия с передачей объекта (см. Локальный портал)

// опрос
bool tick();                        // тикер портала. Вернёт true, если портал запущен

bool form();                        // вернёт true, если было нажатие на любой submit
bool form(String name);             // вернёт true, если был submit с указанной формы
String formName();                  // получить имя теукщей submit формы

bool click();                       // вернёт true, если был клик по (кнопка, чекбокс, свитч, слайдер, селектор)
bool click(String name);            // вернёт true, если был клик по указанному элементу
String clickName();                 // получить имя теукщего кликнутого компонента
String clickText();                 // получить имя текст кликнутого компонента

bool update();                      // вернёт true, если было обновление
bool update(String name);           // вернёт true, если было update с указанного компонента
String updateName();                // вернёт имя обновлённого компонента

void answer(String s);              // отправить ответ на обновление
void answer(int s);
void answer(int16_t* v, int am);         // массив int размерностью am, для графика
void answer(int16_t* v, int am, int dec);// + делитель
void answer(GPcolor col);           // ответ с цветом
void answer(GPdate date);           // ответ с датой
void answer(GPtime time);           // ответ со временем

// список автообновления
list.init(количество);              // инициализировать список, указать количество
list.clear();                       // очистить список
list.add(адрес, имя, тип);          // добавить переменную, указать имя компонента и тип
list.add(адрес, имя формы, имя, тип);   // добавить переменную, имя формы, указать имя компонента и тип

// типы для списка
T_CSTR      - массив char
T_STRING    - строка String
T_TIME      - время типа GPtime
T_DATE      - дата типа GPdate
T_CHECK     - boolean, для чекбокса
T_BYTE      - целое 1 байт
T_INT       - целое 4 байта
T_FLOAT     - float
T_COLOR     - целое 4 байта, для цвета

// дефайны настроек (объявлять ДО ПОДКЛЮЧЕНИЯ БИБЛИОТЕКИ GyverPortal)
#define GP_NO_MDNS      // убрать поддержку mDNS из библиотеки (вход по хосту в браузере)
#define GP_NO_DNS       // убрать поддержку DNS из библиотеки (для режима работы как точка доступа)
```
</details>

<details>
<summary>Хранение и изменение даты GPdate</summary>

```cpp
// структура для хранения даты GPdate
// переменные
uint16_t year;
uint8_t month, day;

// инициализация
GPdate();
GPdate(uint16_t year, uint8_t month, uint8_t day);  // из трёх чисел
GPdate(String str);                                 // из строки вида yyyy-mm-dd

// методы
String encode();            // преобразовать в строку вида yyyy-mm-dd
void decode(String str);    // обновить из строки вида yyyy-mm-dd
```
</details>

<details>
<summary>Хранение и изменение времени GPtime</summary>

```cpp
// структура для хранения даты GPtime
// переменные
uint8_t hour, minute, second;

// инициализация
GPtime();
GPtime(uint8_t hour, uint8_t minute, uint8_t second);   // из трёх чисел
GPtime(String str);                                     // из строки вида hh:mm:ss

// методы
String encode();            // преобразовать в строку вида hh:mm:ss
void decode(String str);    // обновить из строки вида hh:mm:ss
```
</details>

<details>
<summary>Хранение и изменение времени GPunix</summary>

```cpp
// получить unix время для графика
uint32_t GPunix(год, месяц, день, час, минута, секунда);
uint32_t GPunix(год, месяц, день, час, минута, секунда, gmt);
// gmt - часовой пояс, по умолч. 0 (пример: Москва gmt = 3)
// месяц и день начинаются с 1, не с 0!
```
</details>

<details>
<summary>Хранение и изменение цвета GPcolor</summary>

```cpp
// см. пример gpcolor_demo

// структура для хранения цвета GPcolor
// переменные
uint8_t r, g, b;

// инициализация
GPcolor();
GPcolor(uint32_t color);
GPcolor(byte r, byte g, byte b);
GPcolor(String s)           // из строки вида #RRGGBB

// методы
String encode();            // преобразовать в строку вида #RRGGBB
void decode(String str);    // обновить из строки вида #RRGGBB
void setRGB(r, g, b);       // установить цвет побайтно
setHEX(uint32_t col);       // установить 24 бит цвет
uint32_t getHEX();          // получить 24 бит цвет

// к структуре можно присвоить uint32_t число
```
</details>

<details>
<summary>Утилиты</summary>

```cpp
char* splitList(char* str);             // разделить строку на подстроки. Цыганские фокусы
int8_t inList(char* name, char* list);  // получить номер, под которым name входит в list (вида "val1,val2,val3")
int8_t inList(String& name, char* list);

// добавить новое значение в массив с перемоткой (для графиков)
GPaddInt(int16_t val, int16_t* arr, uint8_t am);        // новое значение, массив, размер массива
GPaddUnix(uint32_t val, uint32_t* arr, uint8_t am);     // новое значение, массив, размер массива
GPaddUnixS(int16_t val, uint32_t* arr, uint8_t am);     // добавить секунды, массив, размер массива
```
</details>

### Таблица поддержки режимов работы компонентами

| Компонент/Вызов | form() | click() | update() |
| --------------- |:------:|:-------:|:--------:|
| TITLE           |        |         |    ✔    |
| LABEL           |        |         |    ✔    |
| BUTTON          |        |   ✔     |         |
| BUTTON_MINI     |        |   ✔     |         |
| NUMBER          |   ✔   |   ✔     |    ✔    |
| TEXT            |   ✔   |   ✔     |    ✔    |
| PASS            |   ✔   |   ✔     |    ✔    |
| AREA            |   ✔   |          |    ✔    |
| CHECK           |   ✔   |   ✔     |    ✔    |
| SWITCH          |   ✔   |   ✔     |    ✔    |
| DATE            |   ✔   |   ✔     |    ✔    |
| TIME            |   ✔   |   ✔     |    ✔    |
| SLIDER          |   ✔   |   ✔     |    ✔    |
| COLOR           |   ✔   |   ✔     |    ✔    |
| SELECT          |   ✔   |   ✔     |          |
| LED_RED         |   ✔   |          |    ✔    |
| LED_GREEN       |   ✔   |          |    ✔    |

<a id="usage"></a>
<a id="setup"></a>
## 1. Начало работы
Библиотека может работать как в локальной сети (esp подключается к роутеру), так и в режиме точки доступа (смартфон подключается к esp).

### 1.1 Подключение к роутеру
```cpp
  WiFi.mode(WIFI_STA);
  WiFi.begin("login", "pass");
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  Serial.println(WiFi.localIP());
  // ...
  portal.start();   // запускаем портал
```
Для подключения к порталу нужно зайти в браузере на IP адрес платы, который выдал ей роутер. В примере выше этот адрес выводится в монитор порта.

### 1.2 Обнаружение mDNS, Bonjour
В версии 2.0 библиотеки появилась встроенная возможность запуска функции обнаружения: при запуске портала передаём адрес, 
по которому хотим заходить свою плату в браузере или обнаруживать в локальной сети. Например `portal.start("my_esp")` *без пробелов*. 
Что делать дальше:
- **Windows**
    - Установить утилитку *Bonjour* от Apple, [ссылка на официальный сайт](https://support.apple.com/kb/DL999)
    - Для открытия портала вместо IP адреса использовать `имя.local`, из примера выше - `http://my_esp.local/`
    - Круто же!
- **Android**
    - Скачать из Play Market приложение *Service Browser*
    - Открыть пункт `_http._tcp. (World Wide Web HTTP)`
    - Увидеть там IP адрес платы напротив указанного имени хоста
    - Удобно!

### 1.3 Создание точки
В этом режиме портал нужно запускать `start()` **после** установки режима работы `WIFI_AP`: библиотека определяет текущий режим работы и запускает DNS сервер.
```cpp
  WiFi.mode(WIFI_AP);
  WiFi.softAP("My Portal");
  // ...
  portal.start();   // запускаем портал
```
На стандартных настройках IP адрес для подключения в этом режиме будет `192.168.4.1`

### 1.4 Тикер
В GyverPortal используется стандартная библиотека *ESP8266WebServer*, поэтому 
для обеспечения работы сервера нужно вызывать `portal.tick()` в цикле программы. Возвращает `true`, если сервер запущен в данный момент.

### 1.5 Опрос действий
Взаимодействие между платой и браузером происходит по следующему сценарию: на esp запщуен сервер, браузер является клиентом. 
При открытии портала в браузере esp получает запрос и отправляет страницу. При действиях пользователя (нажал на кнопку) или 
скриптов со стороны браузера (запрос данных) esp получает запрос на действие. В библиотеке начиная с версии 2.0 это реализовано так:
- Создаём свою функцию вида `void f()` или `void f(GyverPortal &p)` (в этот вариант будет автоматически передан ваш экземпляр GyverPortal)
- Подключаем эту функцию в библиотеку: `portal.attach(f)`

Теперь указанная функция будет автоматически вызываться при действии в браузере, их всего три:
- Отправка формы
- Клик по элементу
- Запрос на обновление

### 1.6 Создаём GyverPortal глобально
В этом сценарии объект создан глобально и может опрашиваться в любом месте программы

```cpp
GyverPortal portal;

void build() {
  // конструктор страницы
}

void action() {
  // опрос действий
  // переменная portal в области видимости
}

void setup() {
  // подключаемся к сети
  portal.attachBuild(build);
  portal.attach(action);
  portal.start();
}

void loop() {
  portal.tick();
}
```

### 1.7 Создаём GyverPortal локально
В этом сценарии объект создан локально, например в цикле. Функция-обработчик действий должна содержать 
переданный по ссылке объект портала, чтобы работать вне области определения!

```cpp
void build() {
  // конструктор страницы
}

void action(GyverPortal &p) {
  // опрос действий
  // здесь переменная p является ссылкой на portal (ниже)
  // можно обращаться к ней точно так же, if (p.click())
}

void f() {
  GyverPortal portal;
  portal.attachBuild(build);
  portal.attach(action);
  portal.start();

  while (portal.tick());
}
```
В таком сценарии для выхода из цикла можно вызвать `portal.stop()` по таймауту или кнопке с браузера.

<a id="build"></a>
## 2. Конструктор страниц
Конструктор реализован следующим образом: есть функция, которая сама будет вызываться, когда нужно отправить 
в браузер страницу. В этой функции мы добавляем компоненты на страницу, обращаясь к `GP` с указанием элемента.

### 2.1. Создаём конструктор
Создаём функцию вида: `void f()`. Далее в ней:
1. Запускаем конструктор: `BUILD_BEGIN()`. Здесь добавляется начальный HTML код
2. (Опционально) применяем тему: `GP.THEME(тема)` (GP_LIGHT/GP_DARK)
3. Строим страницу, добавляя компоненты, например `GP.BUTTON(...)`
4. Завершаем работу конструктора: `BUILD_END()`. Здесь добавляется завершающий HTML код

Общий вид функции конструктора:
```cpp
void build() {
  BUILD_BEGIN();
  GP.THEME(GP_LIGHT);
  // собираем страницу
  // ...
  BUILD_END();
}
```

### 2.2 Подключаем функцию конструктора
Передаём в библиотеку нашу функцию-конструктор страницы:
```cpp
portal.attachBuild(build);
```
Библиотека сама будет вызывать её, когда потребуется отобразить страницу. Функций-конструкторов (а следовательно и страниц) может быть несколько и их можно переключать. 

Также сборку страницы можно производить по "условиям", добавляя и убирая компоненты согласно сценарию работы (см. пример menuTabs)

<a id="form"></a>
## 3. Использование форм
### 3.1 Собираем страницу с формами

Основная суть использования форм:
- Форма имеет своё уникальное имя, должно начинаться с `/`
- Внутри формы может быть сколько угодно элементов, но только одна кнопка типа `SUBMIT`
- При нажатии на SUBMIT esp получает имя формы и данные из всех элементов внутри этой формы
- При нажатии на SUBMIT страница перезагружается, поэтому значения компонентов страницы нужно хранить в переменных и передавать при следующей сборке страницы

Пример с двумя формами, первая может передать текст из окна ввода, вторая - только факт нажатия кнопки:
```cpp
форма_1
    ввод текста
    кнопка submit
форма_1

форма_2
    кнопка submit
форма_2
```

В конструкторе GyverPortal это будет выглядеть так:
```cpp
void build() {
  BUILD_BEGIN();               // запустить конструктор
  GP.THEME(GP_LIGHT);          // применить тему

  GP.FORM_BEGIN("/login");     // начать форму, передать имя
  GP.TEXT("txt", "Login", ""); // ввод текста, подсказка Login, текста нет
  GP.BREAK();                  // перенос строки
  GP.SUBMIT("Submit");         // кнопка Submit
  GP.FORM_END();               // завершить форму

  GP.FORM_BEGIN("/exit");      // начать форму, передать имя
  GP.SUBMIT("Exit");           // кнопка Exit
  GP.FORM_END();               // завершить форму

  BUILD_END();                 // завершить построение
}
```
Результат работы конструктора:  
![demo](/docs/demo.png)  
Все инструменты конструктора описаны в документации выше.

### 3.2 Опрос действий
- При нажатии любой кнопки типа `SUBMIT` в браузере функция `form()` вернёт `true`
- Функция должна опрашиваться внутри подключенной в `attach()` функции
- Для поиска формы, с которой пришёл сигнал, используем `form(имя)` - вернёт `true`, если имя совпало
  - Лучше обернуть поиск в `if (form())`, чтобы не тратить процессорное время на сравнение строк

```cpp
void action() {
  if (portal.form()) {
    Serial.print("Submit form: ");
    if (portal.form("/login")) Serial.println("Login");
    if (portal.form("/exit")) Serial.println("Exit");
  }
}
```

### 3.4 Парсинг данных
В библиотеке реализованы готовые инструменты для полученя данных из компонентов формы (см. документацию выше). Например выведем в порт содержимое поля ввода текста:
```cpp
if (portal.form("/login")) Serial.println(portal.getString("txt"));
// где "txt" - имя компонента
```
> Важно! Получать данные с компонента формы можно только внутри условия (здесь `if (portal.form("/name"))`), так как esp не хранит в себе код страницы, она получает конкретные данные только при действии пользователя!

<a id="click"></a>
## 4. Использование кликов
### 4.1 Отличие от форм

В библиотеке реализован механизм, позволяющий обрабатывать действия на странице без её перезагрузки (как при использовании форм):
- Форма позволяет по нажатию одной кнопки получить значения с нескольких компонентов. Страница перезагрузится.
- Клик позволяет получить текущее (изменённое) значение только с кликнутого компонента. *Страница не перезагрузится*.

### 4.2 Опрос действий
- При клике по некоторым компонентам или изменении их значения (см. таблицу в документации) функция `click()` вернёт `true`
- Функция должна опрашиваться внутри подключенной в `attach()` функции
- Для поиска компонента, с которого пришёл сигнал, используем `click(имя)` - вернёт `true`, если имя совпало
  - Лучше обернуть поиск в `if (click())`, чтобы не тратить процессорное время на сравнение строк
```cpp
void action() {
  if (portal.click("mybutton")) Serial.println("Click!");
}
```

### 4.4 Парсинг данных
Парсинг данных от кликов можно производить при помощи тех же функций, что и для форм.
> Важно! Получать данные с компонента формы можно только внутри условия (здесь `if (portal.click("/name"))`), так как esp не хранит в себе код страницы, она получает конкретные данные только при действии пользователя!

### 4.5 Подключение кнопки на другой компонент
Кнопку (BUTTON, BUTTON_MINI) можно "подключить" к другому компоненту: при клике по кнопке будет вызван сигнал `click` с именем кнопки и данными с указанного компонента. Для подключения нужно указать имя компонента третьим аргументом при добавлении кнопки:
```cpp
GP.BUTTON(имя кнопки, текст кнопки, имя компонента);
GP.BUTTON_MINI(имя кнопки, текст кнопки, имя компонента);
```
Пример, клик по кнопке отправляет текст из поля txt:
```cpp
GP.TEXT("txt", "");
GP.BUTTON_MINI("btn", "Send", "txt");
```

<a id="update"></a>
## 5. Использование обновлений
В библиотеке реализован механизм скриптовых запросов со страницы по таймеру. Это позволяет обновлять значения некоторых компонентов и надписей
(см. таблицу в документации) без обновления страницы в браузере.

### 5.1 Подключение обновлений
Для включения режима обновлений нужно добавить в начало страницы блок *AJAX_UPDATE*:
```cpp
void build() {
  BUILD_BEGIN();
  GP.AJAX_UPDATE("name1,name2,name3");
  // ...
  GP.LABEL("NAN", "val");  // будем обновлять текст
  BUILD_END();
}
```

- Функция `AJAX_UPDATE` принимает список имён компонентов, разделённых запятой.
- ПРОБЕЛ ПОСЛЕ ЗАПЯТОЙ НЕ СТАВИМ.
- Также можно указать период запросов на обновления в миллисекундах `GP.AJAX_UPDATE("name1,name2", 5000);`, по умолчанию - 1000 (1 секунда).
- Не все компоненты поддерживают режим обновлений (см. таблицу в документации).

### 5.2 Опрос обновлений
- При наступлении обновления функция `update()` вернёт `true`
- Функция должна опрашиваться внутри подключенной в `attach()` функции
- Для поиска компонента, с которого пришёл сигнал, используем `update(имя)` - вернёт `true`, если имя совпало
  - Лучше обернуть поиск в `if (update())`, чтобы не тратить процессорное время на сравнение строк
- Нужно ответить на запрос обновления при помощи функции `answer()`. В неё передаётся актуальное значение для компонента
- Если не ответить на обновление - библиотека ответит пустым ответом, чтобы страница не зависла

```cpp
void action() {
  if (portal.update("val")) portal.answer(random(1000));
}
```

<a id="auto"></a>
## 6. Автоматическое обновление переменных
**[См. примеры demoSubmitAuto и demoClickAuto]** Вместо ручного парсинга можно указать библиотеке переменные,
которые будут автоматически получать новые значения с указанных компонентов страницы. *Это работает как для форм, так и для кликов.*
- Инициализируем список, вызвав `.list.init(количество)`, передаём размер списка в количестве переменных.
- Добавляем переменную по её адресу:
  - `.list.add(&переменная, имя, тип)` - с указанием имени компонента и его типа
  - `.list.add(&переменная, форма, имя, тип)` - с указанием имени формы, имени компонента и типа

Указанные переменные обновят свои значения при действии с формы с указанным именем или при клике.
Если имя формы не указано - компонент будет парситься при действии с любой формы. *Для работы с кликами не нужно указывать имя формы.*

### 6.1 Поддержка фичи компонентами, связь с типами

| Тип данных    | Тип/Компонент | TEXT/NUMBER | PASS | CHECK | SWITCH | DATE | TIME | SLIDER | COLOR | SELECT | AREA |
| ------------- | ------------- |:-----------:|:----:|:-----:|:------:|:----:|:----:|:------:|:-----:|:------:|:----:|
| `char[]`      | T_CSTR        |  ✔         |  ✔   |       |        |  ✔  |  ✔  |   ✔   |   ✔   |   ✔   |      |
| `String`      | T_STRING      |  ✔         |  ✔   |       |        |  ✔  |  ✔  |   ✔   |   ✔   |   ✔   |      |
| `GPtime`      | T_TIME        |             |      |        |       |      |  ✔  |        |       |        |      |
| `GPdate`      | T_DATE        |             |      |        |       |  ✔  |      |        |       |        |      |
| `bool`        | T_CHECK       |             |      |  ✔    |   ✔   |      |      |        |       |        |      |
| `byte`, `char`| T_BYTE        |  ✔         |  ✔  |        |        |      |      |   ✔   |       |        |      |
| `int`, `long` | T_INT         |  ✔         |  ✔   |       |        |      |      |   ✔   |       |        |      |
| `float`       | T_FLOAT       |  ✔         |  ✔   |       |        |      |      |   ✔   |       |        |      |
| `uint32_t`    | T_COLOR       |             |      |       |        |      |      |        |   ✔   |        |      |

<a id="plots"></a>
## 7. Графики
### 7.1 Общие особенности
#### Совместимость
Графики `AJAX_PLOT` и `PLOT_STOCK` несовместимы в одном интерфейсе!

#### Вывод дробных данных
У всех трёх типов графиков есть аргумент `dec`, по умолчанию равен 0. Это делитель, на который (если отличен от 0) будут делиться значения точек графика и переводиться в `float`. 
Таким образом можно отображать данные с плавающей точкой и не хранить в памяти лишние 2 байта. Получили температуру 22.5 градусов, умножаем на 10 и сохраняем в массив. Вызываем график с `dec`, равным 10.  

#### Несколько осей
Все графики поддерживают вывод по нескольким осям (общая ось X).

#### Подписи
Подписи храним в массиве char, например так:
```cpp
const char *names[] = {"kek", "puk",};
```
#### Обновление статических графиков
Статические графики отображают данные при перезагрузке страницы. Таким образом в конструктор должен быть передан массив с актуальными значениями.  
В библиотеке реализованы функции для удобного добавления нового значения к массиву (с автоматической "перемоткой"):
```cpp
GPaddInt(int16_t val, int16_t* arr, uint8_t am);        // новое значение, массив, размер массива
GPaddUnix(uint32_t val, uint32_t* arr, uint8_t am);     // новое значение, массив, размер массива
GPaddUnixS(int16_t val, uint32_t* arr, uint8_t am);     // добавить секунды, массив, размер массива
```

Например, есть массив `int arr[2][20]` - хранит 20 значений для двух осей графика. Можно обновлять его и хранить в EEPROM, обеспечивая бесперерывную работу. Для добавления нового значения делаем по своему таймеру:
```cpp
GPaddInt(новое, arr[0], 20);
GPaddInt(новое, arr[1], 20);
```
В конструктор передаём как
```cpp
GP.PLOT<2, 20>("table", names, arr);
```

#### Обновление динамических графиков
Динамический график вызывает `update`, отвечаем ему новыми значениями и он строит график в реальном времени. Для передачи значений по нескольким осям используем
`answer(массив, размер)` или `answer(массив, размер, dec)`, где dec имеет смысл делителя (см. выше).


### 7.2 График PLOT
Лёгкий статический график без масштаба  
**[См. пример staticPlot]**  
![demo](/docs/staticPlot.png)  
```cpp
GP.PLOT<к-во осей, к-во данных>(имя, подписи, данные int16_t, int dec = 0)
GP.PLOT_DARK<к-во осей, к-во данных>(имя, подписи, данные int16_t, int dec = 0)
```

### 7.3 График PLOT_STOCK
Статический график с масштабом и привязкой ко времени  
**[См. пример stockPlot]**  
![demo](/docs/stockPlot.png)  
```cpp
GP.PLOT_STOCK<к-во осей, к-во данных>(имя, подписи, массив времён, массив данных, int dec = 0)
GP.PLOT_STOCK_DARK<к-во осей, к-во данных>(имя, подписи, массив времён, массив данных, int dec = 0)
```
Данный график требует для отображения массив даты и времени типа `uint32_t`, содержащий время в формате unix.

### 7.4 График AJAX_PLOT
Динамический график, вызывает update по своему имени, требует ответа  
**[См. пример ajaxPlot]**  
![demo](/docs/ajaxPlot.png)  

```cpp
GP.AJAX_PLOT(имя, к-во осей, к-во точек по Х, период update);
GP.AJAX_PLOT_DARK(имя, к-во осей, к-во точек по Х, период update);
```

<a id="log"></a>
## 8. Лог
В библиотеке реализована возможность делать `print()` в специальное окно лога на странице:
- Окно лога можно создать только одно
- Обновление происходит автоматически, раз в секунду
- Страница не обновляется
- Можно отправлять любые данные, как Serial

### 8.1 Подключение окна лога
Добавляем `GP.AREA_LOG(к-во строк)` в нужное место страницы

### 8.2 Запуск лога
Вызываем `log.start(размер буфера)`. Размер буфера по умолчанию 64 символа
- Примечание: это размер буфера *на стороне библиотеки*, то есть ограничение на количество символов на одну отправку на страницу (раз в секунду). У страницы браузера свой буфер для отображения текста!

### 8.3 Вывод данных
Просто вызываем `log.print()` или `log.println()` как у обычного Serial. См. пример **demoLog**.

<a id="api"></a>
## 9. Свои компоненты, API
### 9.1 Кастомный конструктор
Конструктор GyverPortal ничем не ограничивает построение страницы: достаточно прибавить к строке любой HTML код между запуском `GP_BUILD()` и завершением конструктора `GP_SHOW()`. 
Страница собирается во внутреннюю строку `_GP`, но доступна она по указателю:

```cpp
void build() {
  GP_BUILD();
  // собираем страницу
  *_GP += F("some HTML code");
  GP_SHOW();
}
```

Для справки:  
Стандартный `BUILD_BEGIN()` внутри состоит из:
```cpp
  GP.PAGE_BEGIN();
  GP.AJAX_CLICK();
  GP.PAGE_BLOCK_BEGIN();
```

Стандартный `BUILD_END()` внутри состоит из:
```cpp
 GP.PAGE_BLOCK_END();
 GP.PAGE_END();
```

### 9.2 Свой код
Достаточно прибавить любой HTML код к строке, например:
```cpp
*_GP += F("<input type=\"email\" class=\"myClass\">");
```
Можно обернуть в F macro, чтобы не занимать оперативку.

### 9.3 API
Для обеспечения работоспособности механизмов библиотеки в кастомных компонентах нужно соблюдать следующие моменты:
- Если нужна поддержка кликов - добавить в страницу `GP.AJAX_CLICK()`
- У компонентов формы должен быть указан атрибут *name* для передачи данных через submit.
- У кликабельных компонентов должен быть указан атрибут *onclick* с параметром-функцией: `onclick="GP_click(this)"`. Библиотека сама перехватит вызов и направит в `click()`.
- У компонентов, с которых нужен сигнал `click()` по изменению данных, должен быть указан атрибут *onchange* с параметром-функцией: `onchange="GP_click(this)"`. Библиотека сама перехватит вызов и направит в `click()`.
- У компонентов, для которых нужны обновления `update()`, должен быть указан атрибут `id`. Его значение также нужно передать в `GP.AJAX_UPDATE()`.
- Если нужен клик, который передаёт данные с другого компонента, указываем атрибут с функцией `onclick="GP_clickid(btn,tar)"`, где `btn` - имя (для библиотеки) кликающего компонента, а `tar` - атрибут `id` целевого компонента, с которого нужно передать данные.
- Для ручной передачи в библиотеку сигнала о клике нужно отправить http POST запрос вида `GP_click?имя=значение`
- Для ручной передачи в библиотеку сигнала об обновлении нужно отправить http GET запрос вида `GP_update?id_компонента=`

<a id="versions"></a>
## Версии
- v1.0
- v1.1 - улучшил графики и стили
- v1.2
    - Блок NUMBER теперь тип number
    - Добавил большое текстовое поле AREA
    - Добавил GPunix
    - Улучшил парсинг
    - Добавил BUTTON_MINI
    - Кнопки могут передавать данные с других компонентов (кроме AREA и чекбоксов)
    - Добавил PLOT_STOCK - статический график с масштабом
    - Добавил AJAX_PLOT_DARK
    - Изменён синтаксис у старых графиков
    - Фичи GPaddUnix и GPaddInt для графиков
    - Убрал default тему
    - Подкрутил стили
    - Добавил окно лога AREA_LOG и функцию лога в целом
- v1.3 - переделал GPunix, мелкие фиксы, для списков можно использовать PSTR
- v1.4 - мелкие фиксы, клик по COLOR теперь отправляет цвет
- v1.5 - добавил блок "слайдер+подпись"
- v1.5.1 - мелкий фикс копирования строк
- v1.5.2 - добавлен *meta charset="utf-8"*, английский README (спасибо VerZsuT)
- v1.6 - добавлены инструменты для работы c цветом. Добавил answer() для даты, времени и цвета
- v1.7 - поддержка ESP32

- v2.0: Большое обновление! Логика работы чуть изменена, обнови свои скетчи!
    - Много оптимизации/облегчения/ускорения
    - Полная поддержка ESP32
    - Переделана логика опроса действий (более правильно и оптимально + работает на ESP32) с сохранением легаси
    - Убран DateTimeP (не используется в библиотеке) и вынес отдельно в библиотеку DatePack
    - Переделан и облегчен модуль лога (log)
    - Добавлен MDNS, чтобы не искать IP платы в мониторе порта (см. доку)
    - Автоопределение режима работы WiFi. Переделан start() с сохранением легаси (см. доку)
    - Упрощён билдер, строку создавать и передавать не нужно (см. доку)
    - Объект билдера теперь называется GP (вместо add) с сохранением легаси
    - Пофикшены варнинги
    - Добавлены удобства для работы с цветом GPcolor, датой GPdate и временем GPtime
    - Удалены старые функции преобразования цвета и даты-времени (см. доку)
    - Портал теперь возвращает цвет в формате GPcolor, автообновление переменных тоже работает с GPcolor
    - Все примеры протестированы на esp8266 и esp32

<a id="feedback"></a>
## Баги и обратная связь
При нахождении багов создавайте **Issue**, а лучше сразу пишите на почту [alex@alexgyver.ru](mailto:alex@alexgyver.ru)
Библиотека открыта для доработки и ваших **Pull Request**'ов!

При сообщении о багах или некорректной работе библиотеки нужно обязательно указывать:
- Версия библиотеки
- Какой используется МК
- Версия SDK (для ESP)
- Версия Arduino IDE
- Корректно ли работают ли встроенные примеры, в которых используются функции и конструкции, приводящие к багу в вашем коде
- Какой код загружался, какая работа от него ожидалась и как он работает в реальности
- В идеале приложить минимальный код, в котором наблюдается баг. Не полотно из тысячи строк, а минимальный код